library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Ausgabe auf Expansion Board Trenz Elec.

entity LED_Multiplexer is

port ( CLK, RESET		: in std_logic;
	  BCD_Number_1		: in std_logic_vector( 3 downto 0);
	  BCD_Number_2		: in std_logic_vector( 3 downto 0);
	  BCD_Number_3		: in std_logic_vector( 3 downto 0);
	  BCD_Number_4		: in std_logic_vector( 3 downto 0);
	  DCF_Error		: in std_logic;
	  DCF_Bit_Clk		: in std_logic;
	  DCF_Min_Clk		: in std_logic;
	  Anzeige_Select   : out std_logic_vector (2 downto 0);
	  Seg7_Out	    : out std_logic_vector (6 downto 0) );

end LED_Multiplexer;

architecture SEQUENZ of LED_Multiplexer is

type ZUSTAENDE is ( Z0,Z1,Z2,Z3,Z4);
signal ZUSTAND, FOLGE_Z : ZUSTAENDE;
signal intBCD_Number    : std_logic_vector( 3 downto 0);

begin
Z_SPEICHER: process (CLK, RESET)
	begin
		if  RESET = '1' then 
		
		ZUSTAND <= Z0;
		--Anzeige_Select <= "000";
		--Seg7_Out <= "0000000";  		

		elsif CLK = '1' and CLK'event then
			ZUSTAND <= FOLGE_Z;
		end if;
	end process Z_SPEICHER;

UE_SN: process (ZUSTAND, BCD_Number_1, BCD_Number_2, BCD_Number_3, BCD_Number_4)
	begin
		
			
		case ZUSTAND is

			when Z0 =>	Anzeige_Select <= "010";	-- MUX Ausgabe U5
						intBCD_Number  <= BCD_Number_1;
						FOLGE_Z <= Z1; -- Naechster Zustand
						

			when Z1 =>	Anzeige_Select <= "011";	-- MUX Ausgabe U6
						intBCD_Number  <= BCD_Number_2;
						FOLGE_Z <= Z2; -- Naechster Zustand
						
			when Z2 =>	Anzeige_Select <= "100";	-- MUX Ausgabe U7
						intBCD_Number  <= BCD_Number_3;
						FOLGE_Z <= Z3; -- Naechster Zustand
						
			when Z3 =>	Anzeige_Select <= "101";	-- MUX Ausgabe U8
						intBCD_Number  <= BCD_Number_4;
						FOLGE_Z <= Z4; -- Naechster Zustand
			
			when Z4 =>	Anzeige_Select <= "001";	-- MUX Ausgabe LEDs
						
						intBCD_Number  <= "1111";
						FOLGE_Z <= Z0; -- Naechster Zustand			
	
		end case;
end process UE_SN;

DecodeSeven: process (intBCD_Number, DCF_Error, DCF_Bit_Clk, DCF_Min_Clk)
	begin		
	
		
		case intBCD_Number is

		--      a                  
		--     ---                 
		--  f |   | b             
		--     ---   <- g         
		--  e |   | c             
		--     ---              
		--      d                  
						      --gfedcba
		when "0000" => Seg7_Out <= "0111111";  -- 0
      	when "0001" => Seg7_Out <= "0000110";  -- 1
      	when "0010" => Seg7_Out <= "1011011";  -- 2
      	when "0011" => Seg7_Out <= "1001111";  -- 3
         	when "0100" => Seg7_Out <= "1100110";  -- 4
      	when "0101" => Seg7_Out <= "1101101";  -- 5
      	when "0110" => Seg7_Out <= "1111101";  -- 6
      	when "0111" => Seg7_Out <= "0000111";  -- 7
      	when "1000" => Seg7_Out <= "1111111";  -- 8
      	when "1001" => Seg7_Out <= "1101111";  -- 9
      	when "1111" => Seg7_Out(0) <= DCF_Error;
					Seg7_Out(1) <= '0';
					Seg7_Out(2) <= '0';
					Seg7_Out(3) <= DCF_Bit_Clk;
					Seg7_Out(4) <= '0';
					Seg7_Out(5) <= '0';
					Seg7_Out(6) <= DCF_Min_CLK;
					
					
		when others => Seg7_Out <= "1000000";
		end case;

end process DecodeSeven;

end SEQUENZ;