library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Dieses Modul Synchronisiert das DCF Signal mit dem geteilten Taktsignal
-- des Clock_Generator

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
-- library UNISIM;
-- use UNISIM.VComponents.all;

entity DCF_Syncer is
port ( Reset, CLK, SigIn		: in std_logic;
	  SigOut		  	: out std_logic	);

end DCF_Syncer;

architecture Sync_Logic of DCF_Syncer is
signal intSig: std_logic;
begin

Syncer: process (CLK, Reset)
begin
	
	if Reset = '1' then
	
		intSig <= '0';
		SigOut <= '0'; 
	
	elsif CLK = '1' and CLK'event then
	    		
		intSig <= SigIn;	
		SigOut <= intSig;
	
	end if;

end process Syncer;

end Sync_Logic;
