-- VHDL model created from dcf_uhr.sch - Mon May 23 00:27:26 2005


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity dcf_uhr is
   port ( CLK      : in    std_logic; 
          DCF_Sig  : in    std_logic; 
          Reset    : in    std_logic; 
          MUX      : out   std_logic_vector (2 downto 0); 
          Segmente : out   std_logic_vector (6 downto 0));
end dcf_uhr;

architecture BEHAVIORAL of dcf_uhr is
   attribute BOX_TYPE   : STRING ;
   signal BitClk   : std_logic;
   signal BitV     : std_logic;
   signal Errr     : std_logic;
   signal MinClk   : std_logic;
   signal Min1     : std_logic_vector (3 downto 0);
   signal Min10    : std_logic_vector (3 downto 0);
   signal Std1     : std_logic_vector (3 downto 0);
   signal Std10    : std_logic_vector (3 downto 0);
   signal synced   : std_logic;
   signal XLXN_50  : std_logic;
   component dcf_syncer
      port ( Reset  : in    std_logic; 
             CLK    : in    std_logic; 
             SigIn  : in    std_logic; 
             SigOut : out   std_logic);
   end component;
   
   component pwm_decoder
      port ( sig       : in    std_logic; 
             msClk     : in    std_logic; 
             rst       : in    std_logic; 
             bitVal    : out   std_logic; 
             bitClkOut : out   std_logic; 
             minClkOut : out   std_logic; 
             error     : out   std_logic);
   end component;
   
   component shift
      port ( Unload       : in    std_logic; 
             Reset        : in    std_logic; 
             C            : in    std_logic; 
             SI           : in    std_logic; 
             Stunden_10er : out   std_logic_vector (3 downto 0); 
             Stunden_1er  : out   std_logic_vector (3 downto 0); 
             Minuten_10er : out   std_logic_vector (3 downto 0); 
             Minuten_1er  : out   std_logic_vector (3 downto 0));
   end component;
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : COMPONENT is "BLACK_BOX";
   
   component led_multiplexer
      port ( CLK            : in    std_logic; 
             RESET          : in    std_logic; 
             DCF_Error      : in    std_logic; 
             DCF_Bit_Clk    : in    std_logic; 
             DCF_Min_Clk    : in    std_logic; 
             BCD_Number_1   : in    std_logic_vector (3 downto 0); 
             BCD_Number_2   : in    std_logic_vector (3 downto 0); 
             BCD_Number_3   : in    std_logic_vector (3 downto 0); 
             BCD_Number_4   : in    std_logic_vector (3 downto 0); 
             Anzeige_Select : out   std_logic_vector (2 downto 0); 
             Seg7_Out       : out   std_logic_vector (6 downto 0));
   end component;
   
begin
   XLXI_2 : dcf_syncer
      port map (CLK=>CLK, Reset=>Reset, SigIn=>DCF_Sig, SigOut=>synced);
   
   XLXI_4 : pwm_decoder
      port map (msClk=>CLK, rst=>Reset, sig=>synced, bitClkOut=>BitClk,
            bitVal=>BitV, error=>Errr, minClkOut=>MinClk);
   
   XLXI_5 : shift
      port map (C=>BitClk, Reset=>XLXN_50, SI=>BitV, Unload=>MinClk,
            Minuten_1er(3 downto 0)=>Min1(3 downto 0), Minuten_10er(3 downto
            0)=>Min10(3 downto 0), Stunden_1er(3 downto 0)=>Std1(3 downto 0),
            Stunden_10er(3 downto 0)=>Std10(3 downto 0));
   
   XLXI_6 : OR2
      port map (I0=>Reset, I1=>Errr, O=>XLXN_50);
   
   XLXI_7 : led_multiplexer
      port map (BCD_Number_1(3 downto 0)=>Std10(3 downto 0), BCD_Number_2(3
            downto 0)=>Std1(3 downto 0), BCD_Number_3(3 downto 0)=>Min10(3
            downto 0), BCD_Number_4(3 downto 0)=>Min1(3 downto 0), CLK=>CLK,
            DCF_Bit_Clk=>BitClk, DCF_Error=>Errr, DCF_Min_Clk=>MinClk,
            RESET=>Reset, Anzeige_Select(2 downto 0)=>MUX(2 downto 0),
            Seg7_Out(6 downto 0)=>Segmente(6 downto 0));
   
end BEHAVIORAL;


